/** Esercitazione classi astratte ed ereditariet 
 *  Classe Tempo modificata (focus su toString e equals)
 */

public class Tempo {  

	protected int ore;
	protected int minuti;
	protected int secondi;
	static public char separatore = ':'; 
	
    //costruttore senza argomenti
	public Tempo () { ore = minuti = secondi = 0; }

	public Tempo (int ora, int minuto, int secondo) {
	      this(); //invoca il costruttore senza argomenti
	      assegnaTempo (ora, minuto, secondo);
	}
	
	
	public int assegnaTempo(int ora,int min,int sec){
		if (ora>=0 && ora<24 && min>=0&& min<60 && sec>=0 && sec<60) {
			ore=ora; minuti=min; secondi=sec; 
			return 0;
		} else return -1;
	}

	public int getOre(){ return ore; }
	public int getMinuti(){ return minuti; }
	public int getSecondi(){ return secondi; }

	public void aggiungiOre (int numOre){
		ore+=numOre;
		while (ore>23) ore-=24;
	}
	
/*  PARTE MODIFICATA */

//overriding
public String toString() {
	return String.valueOf(ore) + separatore + String.valueOf(minuti) + separatore + String.valueOf(secondi);
}

//overriding
public boolean equals(Object obj) {
	if (obj == null) return false;
	if (!(obj instanceof Tempo)) return false;
	Tempo t = (Tempo) obj;
	return ((ore == t.ore) && (minuti == t.minuti) && (secondi == t.secondi));
}

public void visualizza (boolean ritornoACapo){
	if (ritornoACapo) System.out.println(this);
	else System.out.print(this);
}

public boolean maggioreDi (Tempo t) {
	  if (ore > t.ore || ore == t.ore && minuti > t.minuti ||
	          ore == t.ore && minuti == t.minuti && secondi > t.secondi)
	         return true;
	      else
		   return false;
	}

} //end-classe Tempo