public class Tempo2 extends Tempo {
	private int centesimi = 0;
	
	public Tempo2 (int ora, int minuto, int secondo, int centesimo) {
	      super(); //invoca il costruttore senza argomenti
	      assegnaTempo (ora, minuto, secondo, centesimo);
	}


	public int assegnaTempo(int ora,int min,int sec, int cent){
		if (ora>=0 && ora<24 && min>=0&& min<60 && sec>=0 && sec<60 && cent>=0 && cent<60) {
			ore=ora; minuti=min; secondi=sec; 
			centesimi=cent;
			return 0;
		} else return -1;
	}

  	public void assegnaCentesimi(int cent){
		this.centesimi = cent ;
  	}

	public int getCentesimi() {
		return centesimi ;
	}
	
	
	//overriding
	public String toString() {
		return super.toString() + separatore+ String.valueOf(centesimi);
		}

	//overriding
	public boolean equals(Object obj) {
		if (obj == null) return false;
		if (!(obj instanceof Tempo2)) return false;
		Tempo2 t = (Tempo2) obj;
		return super.equals(obj) && centesimi == t.centesimi;
	}

public boolean maggioreDi (Tempo2 t) {
	if (super.equals(t))
		return (centesimi > t.centesimi || centesimi == t.centesimi);
	else
		return super.maggioreDi(t);
		}


	public void visualizza (boolean ritornoACapo){
		System.out.print(ore);
		System.out.print(separatore);
		System.out.print(minuti);
		System.out.print(separatore);
		System.out.print(secondi);
		System.out.print(separatore);
		if (ritornoACapo) System.out.println(centesimi);
		else System.out.print(centesimi);
 	}

/***** NB: esempio di codice alternativo: non richiede campi "protected"
	public int assegnaTempo(int ora, int min, int sec, int cent){
		int esitoTempo = super.assegnaTempo(ora,min,sec);
		if (esitoTempo == 0 && cent<60) {
			centesimi=cent;
			return 0;
		}
		else return -1;
	}

******/

} //end-classe Tempo2

